Button button[];
Library library[];
Pub Pub[];
//////////////////////////Background
PImage home;
PImage buttons;

/////////////AllMenu
PImage back;
PImage menuLibrary;
PImage menuReadBackground;
PImage menuRead;
PImage menuReadings;
PImage menuMap;
PImage menuInvite;

//////////////////////////LibraryIN
PImage libraryIN;
PImage titleBookOff;
PImage upload;
//////////////////////////ReadBook
PImage backVERT;
PImage bookFantasy;
//////////////////////////Pub
PImage Pub_event;
PImage Pub_SharkOn;
//////////////////////////Readings
PImage keyboard;
PImage Add;
//////////////////////////Invite
PImage pizzino;

int viewHomepage = 0;
int viewLibrary = 1;
int viewRead = 2;
int viewReadings = 3;
int viewMap = 4;
int viewInvite = 5;
int viewExit = 6;
int viewLibraryIN = 7;
int viewBook = 8;
int viewEvent =9;


int screenMode = viewHomepage;

float progress(float start, float end, float percent) {
  return start + ((end - start) * percent);
}

////////////////////////// Position & Animation Variables

float friction = 0.95;

float x_velocity = - 1;
float x_position = -180;
float x_offset = - 1;
float x_refresh = -180;

float y_velocity = - 1;
float y_position = -30;
float y_offset = - 1;
float y_refresh = -30;

float percentage = 0;

///////////////////////////////INVITE variables
float bx;
float by;
int bh = 301;
int bl = 290;
boolean bover = false;
boolean locked = false;
float bdifx = 0.0; 
float bdify = 0.0; 

boolean moveCheck = false;


/////////////////////////////
int counter=0;
//the number of letters you have to type is the number of times you have to touch the screen
int numberOfLetters;



//////////////////////////////////
void setup() {
  size(480, 320);
  smooth();

  loadImages();
  createButton();
  createLibrary();
  createPub();

  bx= 100; 
  by = 100;

  numberOfLetters = 5;
}


void draw() {
  background(0);

  updateBackground();
  if (screenMode== viewHomepage) {
    drawHomepage();
  }

  else if (screenMode== viewLibrary) {
    drawLibrary();

    percentage = 0;
  }

  else if (screenMode == viewLibraryIN) {
    drawLibraryIN();
  }

  else if (screenMode == viewBook) {
    drawBook();
  }

  else if (screenMode == viewRead) {
    drawRead();
  }

  else if (screenMode == viewReadings) {
    drawReadings();
  }

  else if (screenMode == viewMap) {
    drawMap();
  }

  else if (screenMode == viewEvent) {
    drawEvent();
  }

  else if (screenMode == viewInvite) {
    drawInvite();
  }

  else if (screenMode == viewExit) {
    background(0);
  }
}


void touch1Started() {
  touch1StartedBackground(); 

  if (screenMode == viewHomepage) {
    color c = buttons.get(int (touch1X-x_position), int (touch1Y-y_position));

    if (c== -39936) {
      screenMode = viewReadings;
    }
    if (c== -59904) {
      screenMode = viewMap;
    }
    if(c ==-16746241 ) {
      screenMode = viewLibrary;
    }

    if(c == -16766721) {
      screenMode = viewRead;
    } 

    if (c== -65326) {
      screenMode = viewInvite;
    }
    if (c== -16711776) {
      screenMode = viewExit;
    }
  }

  else if(screenMode == viewInvite) {
    if(bover) { 
      locked = true;
    } 
    else {
      locked = false;
    }
    bdifx = touch1X-bx; 
    bdify = touch1Y-by;
  }

  else if (screenMode == viewReadings) {
    if (counter <= (numberOfLetters+1)) {
      counter+=1;
    }
  }
}


void touch1Moved() {
  if(locked) {
    bx = touch1X-bdifx; 
    by = touch1Y-bdify;
  }
}


void touch1Stopped() {
  locked = false;
}

///////////////////////////////////////menuBACKGROUND
void updateBackground() {

  if(touch1Started) { 
    x_velocity = (touch1X + x_offset) - x_position;
    x_position = touch1X + x_offset;
    y_velocity = (touch1Y + y_offset) - y_position;
    y_position = touch1Y + y_offset;
  }
  else {
    x_velocity = x_velocity * friction;
    x_position = x_position + x_velocity;
    y_velocity = y_velocity * friction;
    y_position = y_position + y_velocity;
  } 
  /////////////////////////////////stoppig edges////////////////////////
  if (x_position > 0) {
    x_position = 0;
  }
  if (x_position < (- 420)) {
    x_position = - 420;
  }
  if (y_position > 0) {
    y_position = 0;
  }
  if (y_position < (- 360)) {
    y_position = - 360;
  }
}



void movetocenter() {

  if(int(x_position) < -175 && int(x_position) > -185 && int(y_position) < -25 && int(y_position) > -35) {
    moveCheck = false;
  }

  if(x_position != -1200 || y_position != -1400) {
    x_velocity = (x_refresh - x_position) * 0.054;
    y_velocity = (y_refresh - y_position) * 0.054;
  }
}


void touch1StartedBackground() {
  if((touch1X > x_position - 1600)&&(touch1X <  x_position + 1600)) {
    x_offset = x_position - touch1X;
  }
  if (touch1Y > (y_position - 1440) && touch1Y <  (y_position + 1440)) {
    y_offset = y_position - touch1Y;
  }
}


/////////////////////////////////menuHOMEPAGE
void drawHomepage() {
  if(moveCheck) {
    movetocenter();
  }

  image (buttons, x_position, y_position);
  image (home, x_position, y_position);

  for (int i = 0; i<button.length; i++) {
    button[i].paint();
  }
}

//////////////////////////////////////////menuLIBRARY
void drawLibrary() {
  image (menuLibrary,x_position, y_position);
  for (int i = 0; i<library.length; i++) {
    library[i].paint();
  }
  image (back, 0, 0);

  if (touch1Started && touch1X>430 && touch1X< 470 && touch1Y>y_position  + 260 && touch1Y< +311) {
    moveCheck = true;
    screenMode = viewHomepage;
  }

  if (touch1Started && touch1X>(x_position +545) && touch1X<(x_position+890) && touch1Y>(y_position +140) && touch1Y<(y_position+311)) {
    screenMode = viewLibraryIN;
  }
}


void drawLibraryIN() {
  background (0);
  image (libraryIN,0,0);
  image (titleBookOff, 29,8);
  image (upload,361, 22);
  image (back, 0, 0);
  
  if (touch1Started && touch1X>38.5 && touch1X<134.5 && touch1Y>41 & touch1Y<96) {
    screenMode = viewBook;
  }
  if (touch1Started && touch1X>430  && touch1X<470 && touch1Y>260 & touch1Y<311) {
    screenMode = viewLibrary;
  }
}

///////////////////////////////////////////////drawBOOK
void drawBook() {
  background (0);
  image (bookFantasy,0,0);
  image (backVERT, 154,3);
  
  if (touch1Started && touch1X>420 && touch1X<467 && touch1Y>9 & touch1Y<45) {
    screenMode = viewLibraryIN;
  }
}

//////////////////////////////////////////////////////menuMAP
void drawMap() {
  image (menuMap,x_position, y_position);
  image (back, 0,0);
  for (int i = 0; i<Pub.length; i++) {
    Pub[i].paint();
  }

  if (touch1Started && touch1X>430 && touch1X<470 && touch1Y>260 & touch1Y<311) { //////////selection BackButton
    moveCheck = true;   
    screenMode = viewHomepage;
  }

  if (touch1Started && touch1X>(x_position+480) && touch1X<(x_position+515) && touch1Y>(y_position+275) && touch1Y<(y_position+338)) { //////////selection of a Pub (the Shark one)
    screenMode = viewEvent;
  }
}

void drawEvent() {
  image (menuMap,x_position, y_position);
  image (back, 0,0);
  image (Pub_event, x_position+500, y_position+260);

  for (int i = 0; i<Pub.length; i++) {
    Pub[i].paint();
  }
  image (Pub_SharkOn,x_position+413,y_position+190);
  if (touch1Started && touch1X>430 && touch1X<470 && touch1Y>260 & touch1Y<311) {
    moveCheck = true;   
    screenMode = viewHomepage;
  }
}

///////////////////////////////////////menuREADINGS
void drawReadings() {
  background(0);
  image (menuReadings,0,0);
  image (back, 0, 0);
  image (Add, 380, 10);

  if (touch1Started && touch1X>430 && touch1X<470 && touch1Y>260 & touch1Y<311) {
    moveCheck = true;   
    screenMode = viewHomepage;
  }

  if (0 < counter && counter < (numberOfLetters+1)) {
    image (keyboard,0,160,480,160);
  }
}

/////////////////////////////////////menuINVITE
void drawInvite() {
  image (menuInvite,0,0);
  image (back, 0, 0);
  if (touch1X > bx-bl && touch1X < bx+bl && touch1Y > by-bh && touch1Y < by+bh) {// Test if the cursor is over the box 
    bover = true;
  } 
  else {
    bover = false;
  }
  image (pizzino, bx,by,bl,bh);

  if (touch1Started && touch1X>430 && touch1X<470 && touch1Y>260 & touch1Y<311) {
    moveCheck = true;  
    screenMode = viewHomepage;
  }
}

void drawRead() {
  image (menuReadBackground,x_position,y_position);
  image (menuRead,0,0);
  image  (back, 0, 0);
  if (touch1Started && touch1X>430 && touch1X<470 && touch1Y>260 & touch1Y<311) {
    screenMode = viewHomepage;
  }

  if (touch1Started && touch1X>45 && touch1X<145 && touch1Y>40 & touch1Y<90) {
    background(0);
  }
}


void loadImages() {

  buttons = loadImage ("buttons.png");
  home = loadImage ("homepage.jpg");
  menuLibrary = loadImage ("menuLibrary.png");
  menuRead = loadImage ("readOn.png");
  menuReadBackground = loadImage ("readBackground.jpg");
  menuReadings = loadImage ("readings.png");
  menuMap = loadImage ("map.png");
  menuInvite = loadImage ("invite.png");

  back = loadImage ("backButton.png");

  //////////////////////////////////////////////////////////LibraryIN
  libraryIN = loadImage ("libraryIN.png");
  titleBookOff = loadImage ("titleBookOff.png");
  upload = loadImage ("upload.png");
  //////////////////////////////////////////////////////////ReadBook
  backVERT = loadImage ("backButtonVERT.png");
  bookFantasy = loadImage ("bookLibrary.png");
  //////////////////////////////////////////////////////////PubEvent
  Pub_event = loadImage ("events.png");
  Pub_SharkOn = loadImage ("SharkPubon.png");
  //////////////////////////////////////////////////////////Readings
  keyboard = loadImage ("keyboard.png");
  Add = loadImage ("add.png");
  //////////////////////////////////////////////////////////Invite
  pizzino = loadImage ("toil.png");
}


class Button {
  float d = 0;
  float x;
  float y;
  float xTarget;
  float yTarget;

  int level;
  PImage img;
  float speed = 1.5;


  Button(int level, float x, float y) {
    this.x = this.xTarget = x;
    this.y = this.yTarget = y;

    this.level = level;
    this.img = loadImage (("button" + level) + ".png");
  }

  void paint() {
    x += (xTarget - x) * speed;
    y += (yTarget - y) * speed;

    image(img, x_position + x, y_position + y);
  }

  void move(float x, float y) {
    this.xTarget = x;
    this.yTarget = y;
  }
}


void createButton() {
  button = new Button[6];
  button[0] = new Button(1,  150, 75); 
  button[1] = new Button(2,  560, 80); 
  button[2] = new Button(3,  600, 270);
  button[3] = new Button(4,  385, 268);
  button[4] = new Button(5,  183, 370);
  button[5] = new Button(6,  490, 375);
}

//////////////////////////////////////////LibraryBUTTONS
class Library {
  float d = 0;
  float x;
  float y;
  float xTarget;
  float yTarget;

  int level;
  PImage img;
  float speed = 1.5;


  Library(int level, float x, float y) {
    this.x = this.xTarget = x;
    this.y = this.yTarget = y;

    this.level = level;
    this.img = loadImage (("library" + level) + ".png");
  }

  void paint() {
    x += (xTarget - x) * speed;
    y += (yTarget - y) * speed;

    image(img, x_position + x, y_position + y);
  }

  void move(float x, float y) {
    this.xTarget = x;
    this.yTarget = y;
  }
}


void createLibrary() {
  library = new Library[6];
  library[0] = new Library(1,  380,100); 
  library[1] = new Library(2,  130, 350); 
  library[2] = new Library(3,  100, 130);
  library[3] = new Library(4,  560, 370);
  library[4] = new Library(5,  298,315);
  library[5] = new Library(6,  578,190);
}

//////////////////////////////////////////PUB_buttons
class Pub {
  float d = 0;
  float x;
  float y;
  float xTarget;
  float yTarget;

  int level;
  PImage img;
  float speed = 1.5;


  Pub(int level, float x, float y) {
    this.x = this.xTarget = x;
    this.y = this.yTarget = y;

    this.level = level;
    this.img = loadImage (("Pub" + level) + ".png");
  }

  void paint() {
    x += (xTarget - x) * speed;
    y += (yTarget - y) * speed;

    image(img, x_position + x, y_position + y);
  }

  void move(float x, float y) {
    this.xTarget = x;
    this.yTarget = y;
  }
}


void createPub() {
  Pub = new Pub[4];
  Pub[0] = new Pub(1,  222,285); 
  Pub[1] = new Pub(2,  450,115); 
  Pub[2] = new Pub(3,  413,190);
  Pub[3] = new Pub(4,  245,128);
}

